<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: common.php 3327 2005-06-09 15:11:22Z andrew $
*/

require_once MAX_PATH . '/lib/max/Admin_DA.php';

    // +---------------------------------------+
    // | generic permission checks             |
    // |                                       |
    // | filtering by user type                |
    // +---------------------------------------+
    
    
function MAX_checkAd($advertiserId, $placementId, $adId)
{
    $allowed = false;
    if (is_numeric($advertiserId) && is_numeric($placementId) && is_numeric($adId)) {
        if (phpAds_isUser(phpAds_Admin)) {
        
            //  determine if there are 1 or more ads
            $allowed = (count(
                Admin_DA::getAds(
                    array(  
                        'advertiser_id' => $advertiserId, 
                        'placement_id' => $placementId, 
                        'ad_id' => $adId))));
        } elseif (phpAds_isUser(phpAds_Agency)) {
        
            //  determine if there are 1 or more ads
            $allowed = (count(
                Admin_DA::getAds(
                    array(
                        'agency_id' => phpAds_getAgencyID(), 
                        'advertiser_id' => $advertiserId, 
                        'placement_id' => $placementId, 
                        'ad_id' => $adId))));
        } elseif (phpAds_isUser(phpAds_Client)) {
            $allowed = ($advertiserId == phpAds_getUserID()) 
                        && count(Admin_DA::getAds(
                            array(  'advertiser_id' => $advertiserId, 
                                    'placement_id' => $placementId, 
                                    'ad_id' => $adId)));
        }
    }
    return $allowed;
}

function MAX_checkAdvertiser($advertiserId)
{
    $allowed = false;
    if (is_numeric($advertiserId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getAdvertisers(array('advertiser_id' => $advertiserId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = count(Admin_DA::getAdvertisers(
                array(  'agency_id' => phpAds_getAgencyID(),
                        'advertiser_id' => $advertiserId)));
        } elseif (phpAds_isUser(phpAds_Client)) {
            $allowed = ($advertiserId == phpAds_getUserID())
                        && count(Admin_DA::getAdvertisers(array('advertiser_id' => $advertiserId)));
        }
    }
    return $allowed;
}

function MAX_checkAgency($agencyId)
{
    $allowed = false;
    if (is_numeric($agencyId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getAgencies(array('agency_id' => $agencyId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = ($agencyId == phpAds_getUserId())
                        && count(Admin_DA::getAgencies(array('agency_id' => $agencyId)));        
        } elseif (phpAds_isUser(phpAds_Client)) {
            $allowed = ($agencyId == phpAds_getAgencyID())
                        && count(Admin_DA::getAgencies(array('agency_id' => $agencyId)));
        }
    }
    return $allowed;
}

function MAX_checkPublisher($publisherId)
{
    $allowed = false;
    if (is_numeric($publisherId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getPublishers(array('publisher_id' => $publisherId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = count(Admin_DA::getPublishers(
                array(  'agency_id' => phpAds_getAgencyID(),
                        'publisher_id' => $publisherId)));
        } elseif (phpAds_isUser(phpAds_Affiliate)) {
            $allowed = ($publisherId == phpAds_getUserID())
                        && count(Admin_DA::getPublishers(array('publisher_id' => $publisherId)));
        }
    }
    return $allowed;
}

function MAX_checkPlacement($advertiserId, $placementId)
{
    $allowed = false;
    if (is_numeric($advertiserId) && is_numeric($placementId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getPlacements(
                array(  'advertiser_id' => $advertiserId,
                        'placement_id' => $placementId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = count(Admin_DA::getPlacements(
                array(  'agency_id' => phpAds_getAgencyID(),
                        'advertiser_id' => $advertiserId,
                        'placement_id' => $placementId)));
        } elseif (phpAds_isUser(phpAds_Client)) {
            $allowed = ($advertiserId == phpAds_getUserID())
                        && count(Admin_DA::getPlacements(
                array(  'advertiser_id' => $advertiserId,
                        'placement_id' => $placementId))); 
        }
    }
    return $allowed;
}

function MAX_checkTracker($advertiserId, $trackerId)
{
    $allowed = false;
    if (is_numeric($advertiserId) && is_numeric($trackerId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getTrackers(
                array(  'advertiser_id' => $advertiserId,
                        'tracker_id' => $trackerId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = count(Admin_DA::getTrackers(
                array(  'agency_id' => phpAds_getAgencyID(),
                        'advertiser_id' => $advertiserId,
                        'tracker_id' => $trackerId)));
        } elseif (phpAds_isUser(phpAds_Client)) {
            $allowed = ($advertiserId == phpAds_getUserID())
                        && count(Admin_DA::getTrackers(
                array(  'advertiser_id' => $advertiserId,
                        'tracker_id' => $trackerId)));
        }
    }
    return $allowed;
}

function MAX_checkZone($publisherId, $zoneId)
{
    $allowed = false;
    if (is_numeric($publisherId) && is_numeric($zoneId)) {
        if (phpAds_isUser(phpAds_Admin)) {
            $allowed = count(Admin_DA::getZones(
                array(  'publisher_id' => $publisherId,
                        'zone_id' => $zoneId)));
        } elseif (phpAds_isUser(phpAds_Agency)) {
            $allowed = count(Admin_DA::getZones(
                array(  'agency_id' => phpAds_getAgencyID(),
                        'publisher_id' => $publisherId,
                        'zone_id' => $zoneId)));
        } elseif (phpAds_isUser(phpAds_Affiliate)) {
            $allowed = ($publisherId == phpAds_getUserID())
                        && count(Admin_DA::getZones(
                array(  'publisher_id' => $publisherId,
                        'zone_id' => $zoneId)));
        }
    }
    return $allowed;
}

function MAX_checkAdZoneValid($aZone, $aAd)
{
    $valid = true;
    if ($aZone['width'] > -1 && $aZone['width'] != $aAd['width']) {
        $valid = false;
    } elseif ($aZone['height'] > -1 && $aZone['height'] != $aAd['height']) {
        $valid = false;
    } elseif ($aAd['type'] == 'txt' && $aZone['type'] != phpAds_ZoneText) {
        $valid = false;
    } elseif ($aZone['type'] == phpAds_ZoneText && $aAd['type'] != 'txt') {
        $valid = false;
    }
    return $valid;
}






# rename to getAdName()
function MAX_getBannerName($description, $alt)
{
    global $strUntitled;

    $name = $strUntitled;
    if (!empty($alt)) $name = $alt;
    if (!empty($description)) $name = $description;
    $name = phpAds_breakString ($name, '30');

    return $name;
}


    // +---------------------------------------+
    // | $_REQUEST methods                     |
    // |                                       |
    // | and handling magic quotes             |
    // +---------------------------------------+
function MAX_getValue($key, $default = null)
{
    $value = $default;
    if (isset($_REQUEST[$key])) {
        $value = $_REQUEST[$key];
        if (!get_magic_quotes_gpc()) {
            MAX_addslashes($value);
        }
    }

    return $value;
}

function MAX_getStoredValue($key, $default)
{
    global $session;
    $pageName = basename($_SERVER['PHP_SELF']);

    $value = $default;
    if (isset($_REQUEST[$key])) {
        $value = $_REQUEST[$key];
        if (!get_magic_quotes_gpc()) MAX_addslashes($value);
    } elseif (isset($session['prefs'][$pageName][$key])) {
        $value = $session['prefs'][$pageName][$key];
    }

    return $value;
}

function MAX_addslashes(&$item)
{
    if (isset($item)) {
        if (is_array($item)) {
            array_walk($item, 'MAX_addslashes');
        } else {
            $item = addslashes($item);
        }
    }
}








    // +---------------------------------------+
    // | array utilties                        |
    // +---------------------------------------+

// this is never called
function MAX_arrayMergeRecursive(&$a, &$b)
{
    $keys = array_keys($a);
    foreach ($keys as $key) {
        if (isset($b[$key])) {
            if (is_array($a[$key]) && is_array($b[$key])) {
                //????????? the 'merge' fn not only is not a PHP fn, it's not defined anywhere, go figure ...
                merge($a[$key], $b[$key]);
            } else {
                $a[$key] = $b[$key];
            }
        }
    }
    $keys = array_keys($b);
    foreach ($keys as $key) {
        if (!isset($a[$key])) {
            $a[$key] = $b[$key];
        }
    }
}

function MAX_getStoredArray($key, $default)
{
    global $session;
    $pageName = basename($_SERVER['PHP_SELF']);

    $value = $default;
    if (isset($_REQUEST[$key])) {
        $value = explode(',',$_REQUEST[$key]);
        if (!get_magic_quotes_gpc()) {
            MAX_addslashes($value);
        }
    } elseif (isset($session['prefs'][$pageName][$key])) {
        $value = explode(',',$session['prefs'][$pageName][$key]);
    }
    return $value;
}









    // +---------------------------------------+
    // | tree node state handling              |
    // +---------------------------------------+
function MAX_adjustNodes(&$aNodes, $expand, $collapse)
{
    if (!empty($expand)) {
        if ($expand != 'all') {
            if ($expand == 'none') {
                $aNodes = array();
            }
            elseif (!in_array($expand, $aNodes)) {
                $aNodes[] = $expand;
            }
        }
    }

    if (!empty($collapse) && in_array($collapse, $aNodes) ) {
        unset($aNodes[array_search($collapse, $aNodes)]);
    }
}

/**
 * Determine if a node is expanded or not.
 *
 * @param integer $id
 * @param string $expand
 * @param array $aNodes
 * @param string $prefix
 * @return boolean
 */
function MAX_isExpanded($id, $expand, &$aNodes, $prefix)
{
    $isExpanded = false;
    if ($expand == 'all') {
        $isExpanded = true;
        if (!in_array($prefix . $id, $aNodes)) {
            $aNodes[] = $prefix . $id;
        }
    } elseif ($expand != 'none' && in_array($prefix . $id, $aNodes)) {
        $isExpanded = true;
    }

    return $isExpanded;
}






    // +---------------------------------------+
    // | adjustments                           |
    // +---------------------------------------+
function MAX_addDefaultPlacementZones($adId, $placementId)
{
    $aAdZones = Admin_DA::getAdZones(array('ad_id' => $adId), true, 'zone_id');
    $aPlacementZones = Admin_DA::getPlacementZones(array('placement_id' => $placementId), true, 'zone_id');
    if (!empty($aPlacementZones)) {
        foreach ($aPlacementZones as $zoneId => $aPlacementZone) {
            if (!isset($aAdZones[$zoneId])) {
                Admin_DA::addAdZone(array('ad_id' => $adId, 'zone_id' => $zoneId));
            }
        }
    }
}
// For a given ad id, make sure that zones have correct size/type.  Otherwise, unlink ads from the zone...
function MAX_adjustAdZones($adId)
{
    $aAdZones = Admin_DA::getAdZones(array('ad_id' => $adId), true, 'zone_id');
    if (!empty($aAdZones)) {
        $aAd = Admin_DA::getAd($adId);
        $aZones = Admin_DA::getZones(array('zone_id' => implode(',', array_keys($aAdZones))));
        foreach ($aZones as $zoneId => $aZone) {
            if (!MAX_checkAdZoneValid($aZone, $aAd)) {
                Admin_DA::deleteAdZones(array('zone_id' => $zoneId, 'ad_id' => $adId));
            }
        }
    }
}

function MAX_adjustZoneAds($zoneId)
{
    $aAdZones = Admin_DA::getAdZones(array('zone_id' => $zoneId), true, 'ad_id');
    if (!empty($aAdZones)) {
        $aZone = Admin_DA::getZone($zoneId);
        $aAds = Admin_DA::getAds(array('ad_id' => implode(',', array_keys($aAdZones))));
        foreach ($aAds as $adId => $aAd) {
            if (!MAX_checkAdZoneValid($aZone, $aAd)) {
                Admin_DA::deleteAdZones(array('zone_id' => $zoneId, 'ad_id' => $adId));
            }
        }
    }
}

function MAX_addLinkedAdsToZone($zoneId, $placementId)
{
    $aParams = MAX_getLinkedAdParams($zoneId);
    $aParams['placement_id'] = $placementId;

    $aAds = Admin_DA::getAds($aParams);
    //  FIXME
    $aLinkedAds = Admin_DA::getAdZones(array('zone_id' => $zoneId), false, 'ad_id');
    foreach ($aAds as $adId => $aAd) {
        if (!isset($aLinkedAds[$adId])) {
            Admin_DA::addAdZone(array('zone_id' => $zoneId, 'ad_id' => $adId));
        }
    }
}

// Get ad limitation parameters
function MAX_getLinkedAdParams($zoneId)
{
    $aParams = array();
    $aZone = Admin_DA::getZone($zoneId);
    if ($aZone['type'] == phpAds_ZoneText) {
        $aParams['ad_type'] = 'txt';
    } else {
        if ($aZone['width'] > -1) {
            $aParams['ad_width'] = $aZone['width'];
        }
        if ($aZone['height'] > -1) {
            $aParams['ad_height'] = $aZone['height'];
        }
    }
    return $aParams;
}







    // +---------------------------------------+
    // | file handling                         |
    // +---------------------------------------+
function MAX_removeFile($adId)
{
    $aAd =  Admin_DA::getAd($adId);
#    $aAd = MAX_getEntity('ad', $adId);
    _removeFile($aAd);
}

function MAX_removeFiles($aParams)
{
    $aAds =  Admin_DA::getAds($aParams);
    foreach ($aAds as $aAd) {
        _removeFile($aAd);
    }
}

function _removeFile($aAd)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $pref = $GLOBALS['_MAX']['PREF'];
    if (!empty($aAd['filename'])) {
        if ($aAd['type'] == 'web') {
            if ($phpAds_config['type_web_mode'] == 0) {
                $fileName = "{$phpAds_config['type_web_dir']}/{$aAd['filename']}";
                if (@file_exists($fileName)) {
                    @unlink ($fileName);
                }
            } else {
                // FTP mode
                $server = parse_url($phpAds_config['type_web_ftp']);
                if ($server['path'] != '' && substr($server['path'], 0, 1) == '/') {
                    $server['path'] = substr ($server['path'], 1);
                }
                if ($server['scheme'] == 'ftp') {
                    $conn_id = @ftp_connect($server['host']);
                    if ($server['pass'] && $server['user'])
                    $login = @ftp_login ($conn_id, $server['user'], $server['pass']);
                    else
                    $login = @ftp_login ($conn_id, 'anonymous', $pref['admin_email']);
                    if (($conn_id) || ($login)) {
                        if ($server['path'] != '')
                        @ftp_chdir ($conn_id, $server['path']);
                        if (@ftp_size ($conn_id, $aAd['filename']) > 0) {
                            @ftp_delete ($conn_id, $aAd['filename']);
                        }
                        @ftp_quit($conn_id);
                    }
                }
            }
        } elseif ($aAd['type'] == 'sql') {
            Admin_DA::deleteImage($aAd['filename']);
        }
    }
}

?>